=== src/easylzma/Makefile ===
# CMAKE generated file: DO NOT EDIT!
# Generated by "Unix Makefiles" Generator, CMake Version 3.10

# Default target executed when no arguments are given to make.
default_target: all

.PHONY : default_target

# Allow only one "make -f Makefile2" at a time, but pass parallelism.
.NOTPARALLEL:


#=============================================================================
# Special targets provided by cmake.

# Disable implicit rules so canonical targets will work.
.SUFFIXES:


# Remove some rules from gmake that .SUFFIXES does not remove.
SUFFIXES =

.SUFFIXES: .hpux_make_needs_suffix_list


# Suppress display of executed commands.
$(VERBOSE).SILENT:


# A target that is always out of date.
cmake_force:

.PHONY : cmake_force

#=============================================================================
# Set environment variables for the build.

# The shell in which to execute make rules.
SHELL = /bin/sh

# The CMake executable.
CMAKE_COMMAND = /usr/bin/cmake

# The command to remove a file.
RM = /usr/bin/cmake -E remove -f

# Escaping for special characters.
EQUALS = =

# The top-level source directory on which CMake was run.
CMAKE_SOURCE_DIR = /home/fangq/space/git/Project/github/zmat/src/easylzma

# The top-level build directory on which CMake was run.
CMAKE_BINARY_DIR = /home/fangq/space/git/Project/github/zmat/src/easylzma

#=============================================================================
# Targets provided globally by CMake.

# Special rule for the target rebuild_cache
rebuild_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running CMake to regenerate build system..."
	/usr/bin/cmake -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)
.PHONY : rebuild_cache

# Special rule for the target rebuild_cache
rebuild_cache/fast: rebuild_cache

.PHONY : rebuild_cache/fast

# Special rule for the target edit_cache
edit_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "No interactive CMake dialog available..."
	/usr/bin/cmake -E echo No\ interactive\ CMake\ dialog\ available.
.PHONY : edit_cache

# Special rule for the target edit_cache
edit_cache/fast: edit_cache

.PHONY : edit_cache/fast

# The main all target
all: cmake_check_build_system
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(CMAKE_COMMAND) -E cmake_progress_start /home/fangq/space/git/Project/github/zmat/src/easylzma/CMakeFiles /home/fangq/space/git/Project/github/zmat/src/easylzma/src/CMakeFiles/progress.marks
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f CMakeFiles/Makefile2 src/all
	$(CMAKE_COMMAND) -E cmake_progress_start /home/fangq/space/git/Project/github/zmat/src/easylzma/CMakeFiles 0
.PHONY : all

# The main clean target
clean:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f CMakeFiles/Makefile2 src/clean
.PHONY : clean

# The main clean target
clean/fast: clean

.PHONY : clean/fast

# Prepare targets for installation.
preinstall: all
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f CMakeFiles/Makefile2 src/preinstall
.PHONY : preinstall

# Prepare targets for installation.
preinstall/fast:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f CMakeFiles/Makefile2 src/preinstall
.PHONY : preinstall/fast

# clear depends
depend:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(CMAKE_COMMAND) -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles/Makefile.cmake 1
.PHONY : depend

# Convenience name for target.
src/CMakeFiles/easylzma_s.dir/rule:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f CMakeFiles/Makefile2 src/CMakeFiles/easylzma_s.dir/rule
.PHONY : src/CMakeFiles/easylzma_s.dir/rule

# Convenience name for target.
easylzma_s: src/CMakeFiles/easylzma_s.dir/rule

.PHONY : easylzma_s

# fast build rule for target.
easylzma_s/fast:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/build
.PHONY : easylzma_s/fast

# Convenience name for target.
src/CMakeFiles/easylzma.dir/rule:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f CMakeFiles/Makefile2 src/CMakeFiles/easylzma.dir/rule
.PHONY : src/CMakeFiles/easylzma.dir/rule

# Convenience name for target.
easylzma: src/CMakeFiles/easylzma.dir/rule

.PHONY : easylzma

# fast build rule for target.
easylzma/fast:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/build
.PHONY : easylzma/fast

common_internal.o: common_internal.c.o

.PHONY : common_internal.o

# target to build an object file
common_internal.c.o:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/common_internal.c.o
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/common_internal.c.o
.PHONY : common_internal.c.o

common_internal.i: common_internal.c.i

.PHONY : common_internal.i

# target to preprocess a source file
common_internal.c.i:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/common_internal.c.i
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/common_internal.c.i
.PHONY : common_internal.c.i

common_internal.s: common_internal.c.s

.PHONY : common_internal.s

# target to generate assembly for a file
common_internal.c.s:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/common_internal.c.s
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/common_internal.c.s
.PHONY : common_internal.c.s

compress.o: compress.c.o

.PHONY : compress.o

# target to build an object file
compress.c.o:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/compress.c.o
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/compress.c.o
.PHONY : compress.c.o

compress.i: compress.c.i

.PHONY : compress.i

# target to preprocess a source file
compress.c.i:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/compress.c.i
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/compress.c.i
.PHONY : compress.c.i

compress.s: compress.c.s

.PHONY : compress.s

# target to generate assembly for a file
compress.c.s:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/compress.c.s
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/compress.c.s
.PHONY : compress.c.s

decompress.o: decompress.c.o

.PHONY : decompress.o

# target to build an object file
decompress.c.o:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/decompress.c.o
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/decompress.c.o
.PHONY : decompress.c.o

decompress.i: decompress.c.i

.PHONY : decompress.i

# target to preprocess a source file
decompress.c.i:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/decompress.c.i
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/decompress.c.i
.PHONY : decompress.c.i

decompress.s: decompress.c.s

.PHONY : decompress.s

# target to generate assembly for a file
decompress.c.s:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/decompress.c.s
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/decompress.c.s
.PHONY : decompress.c.s

lzip_header.o: lzip_header.c.o

.PHONY : lzip_header.o

# target to build an object file
lzip_header.c.o:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/lzip_header.c.o
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/lzip_header.c.o
.PHONY : lzip_header.c.o

lzip_header.i: lzip_header.c.i

.PHONY : lzip_header.i

# target to preprocess a source file
lzip_header.c.i:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/lzip_header.c.i
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/lzip_header.c.i
.PHONY : lzip_header.c.i

lzip_header.s: lzip_header.c.s

.PHONY : lzip_header.s

# target to generate assembly for a file
lzip_header.c.s:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/lzip_header.c.s
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/lzip_header.c.s
.PHONY : lzip_header.c.s

lzma_header.o: lzma_header.c.o

.PHONY : lzma_header.o

# target to build an object file
lzma_header.c.o:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/lzma_header.c.o
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/lzma_header.c.o
.PHONY : lzma_header.c.o

lzma_header.i: lzma_header.c.i

.PHONY : lzma_header.i

# target to preprocess a source file
lzma_header.c.i:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/lzma_header.c.i
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/lzma_header.c.i
.PHONY : lzma_header.c.i

lzma_header.s: lzma_header.c.s

.PHONY : lzma_header.s

# target to generate assembly for a file
lzma_header.c.s:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/lzma_header.c.s
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/lzma_header.c.s
.PHONY : lzma_header.c.s

pavlov/7zBuf.o: pavlov/7zBuf.c.o

.PHONY : pavlov/7zBuf.o

# target to build an object file
pavlov/7zBuf.c.o:
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma_s.dir/build.make src/CMakeFiles/easylzma_s.dir/pavlov/7zBuf.c.o
	cd /home/fangq/space/git/Project/github/zmat/src/easylzma && $(MAKE) -f src/CMakeFiles/easylzma.dir/build.make src/CMakeFiles/easylzma.dir/pavlov/7zBuf.c.o
.PHONY : pavlov/7zBuf.c.o

pavlov/7zBuf.i: pavlov/7zBuf.c.i

.PHONY : pavlov/7zBuf.i

# target to preprocess a source file
pavlov/7zBuf.c.i:
