=== src/blosc2/plugins/CMakeLists.txt ===
add_subdirectory(codecs)
add_subdirectory(filters)

set(SOURCES ${SOURCES} ../plugins/plugin_utils.c ../plugins/plugin_utils.h PARENT_SCOPE)
