=== debian/changelog ===
zmat (0.9.9+ds.1-3) unstable; urgency=medium

  * Team upload
  * No longer depend on embedded versions of zlib and blosc2
    * d/control: add Build-Depends on libblosc2-dev
    * no-embedded-lib.patch: new patch
    * d/rules: various clean-ups
    Incidentally, this means that we no longer build some files with -msse2 on
    all arches. (Closes: #1068683)
  * sanitize-flags.patch: new patch, ensures that correct build flags are used
  * Remove duplicate changelog file
  * Bump Standards-Version to 4.7.0

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 07 Aug 2024 11:50:29 +0200

zmat (0.9.9+ds.1-2) unstable; urgency=medium

  * d/s/options: Drop useless file

 -- Rafael Laboissière <rafael@debian.org>  Wed, 03 Apr 2024 05:43:29 -0300

zmat (0.9.9+ds.1-1) unstable; urgency=medium

  * Team upload
  * New upstream version 0.9.9+ds.1
  * Update upstream URLs
  * d/p/honor-cflags-cppflags-ldflags.patch: Drop patch (applied upstream)
  * d/copyright: Reflect upstream changes
  * d/control:
    + Bump Standards-Version to 4.6.2 (no changes needed)
    + Exclude files CMakeCache.txt and shuffle-avx2.c.orig from repacked tarball
  * d/rules: Use example/ directory instead of test/
  * Use libzstd instead of libz
    + d/rules: Link against -lzstd intead of -lz
    + d/control: Build-depend on libzstd-dev instead of zlib1g-dev
  * d/clean: New file
  * d/s/options: New file

 -- Rafael Laboissière <rafael@debian.org>  Wed, 03 Apr 2024 04:46:51 -0300

zmat (0.9.8+ds-8) unstable; urgency=medium

  * Team upload
  * Add missing Breaks+Replaces against old libzmat1-dev package
    (Closes: #1035012)

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 28 Apr 2023 19:24:04 +0200

zmat (0.9.8+ds-7) unstable; urgency=medium

  * Team upload
  * matlab-zmat.postinst: fix building of zipmat MEX

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 08 Apr 2022 11:42:27 +0200

zmat (0.9.8+ds-6) unstable; urgency=medium

  * Team upload
  * d/control: Bump Standards-Version to 4.6.0 (no changes needed)
  * d/p/honor-cflags-cppflags-ldflags.patch: New patch
  * d/copyright: Update copyright year for the debian/* files

 -- Rafael Laboissière <rafael@debian.org>  Sat, 20 Nov 2021 17:00:03 -0300

zmat (0.9.8+ds-5) unstable; urgency=medium

  * Team upload
  * Upload to unstable (really, closes: #986104)

 -- Rafael Laboissière <rafael@debian.org>  Mon, 16 Aug 2021 13:02:10 -0300

zmat (0.9.8+ds-4) experimental; urgency=medium

  * Team upload
  * Rename libzmat1-dev to libzmat-dev (Closes: #986104)
  * Bump Standards-Version to 4.5.1 (no changes needed)

 -- Rafael Laboissière <rafael@debian.org>  Tue, 06 Jul 2021 02:05:49 -0300
