=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE =1

OCTDIR=$(shell octave-config --print LOCALOCTFILEDIR)

%:
	+dh $@

execute_before_dh_auto_clean:
	$(MAKE) -C src clean

override_dh_auto_build:
	$(MAKE) -C src lib
	$(MAKE) -C src oct
	$(MAKE) -C src dll

override_dh_auto_install:
	install -d debian/libzmat-dev/usr/include;
	install include/zmatlib.h debian/libzmat-dev/usr/include;
	install fortran90/zmatlib.f90 debian/libzmat-dev/usr/include;

	set -e; arch=$$(dpkg-architecture -qDEB_HOST_MULTIARCH); \
	install -d debian/libzmat1/usr/lib/$$arch; \
	install -d debian/libzmat-dev/usr/lib/$$arch; \
	mv lib/libzmat.so debian/libzmat1/usr/lib/$$arch/libzmat.so.1; \
	mv lib/libzmat.a debian/libzmat1/usr/lib/$$arch/libzmat.a; \
	ln -sf libzmat.so.1 debian/libzmat-dev/usr/lib/$$arch/libzmat.so
	
	chmod -x zipmat.mex
	dh_install -poctave-zmat zipmat.mex $(OCTDIR)/zmat
	dh_install -poctave-zmat zmat.m $(OCTDIR)/zmat
	dh_octave_substvar -poctave-zmat
