=== debian/watch ===
version=4

opts="compression=gz, oversionmangle=s/(.*)/$1+ds/, dversionmangle=s/\+ds(\.\d+)?$//, \
    filenamemangle=s/\S+\/v?(\S+)\.tar\.gz/zmat-$1\.tar\.gz/" \
    https://github.com/NeuroJSON/zmat/tags .*/v?(\d\S+)\.tar\.gz \
    debian debian/repack
